# misplib
This crate contains all data structures present in the [MISP API](https://www.misp-project.org/openapi/), and accompanying helper functions.

## Versioning system
For every commit in the [main MISP repository](https://github.com/MISP/MISP) which changes the [API definition](https://raw.githubusercontent.com/MISP/MISP/develop/app/webroot/doc/openapi.yaml) a new version of misplib is created. Version numbers are assigned as ascending integers.

Multiple versions of misplib can be accessed, they are defined in `src/v<version number>/mod.rs`, in this file you can also find the unique commit hash of the MISP repository this version is developed for.

## Contributing
You can contribute to this project by
- adding tests to existing types
- proposing a new version if you detected a change in the MISP API
- adding helper functions (such as implementations of useful traits etc.)
- working on the serialization and deserialization of all types. The goal is to be automatically parse any MISP API object into valid rust misplib objects.
- anything else you can think of :)

## Contact
Feel free to discuss and ask questions in https://matrix.to/#/#misplib:a-0.me