use regex_macro::regex;


default_derive!{
    pub struct EventAttributeCount {
        count: String
    }
}

impl TryFrom<&str> for EventAttributeCount {
    type Error = &'static str;

    fn try_from(value: &str) -> Result<Self, Self::Error> {
        let re = regex!("^[[:digit:]]+$");
        if re.is_match(value) {
            Ok(EventAttributeCount { count: value.to_string() })
        }
        else {
            Err("Failed to parse EventId")
        }
    }
}

impl Into<String> for EventAttributeCount {
    fn into(self) -> String {
        self.count
    }
}

#[test]
fn empty() {
    let id: Result<EventAttributeCount, _> = "".try_into();
    assert!(id.is_err())
}

#[test]
fn valid1() {
    let id: Result<EventAttributeCount, _> = "12345".try_into();
    assert_eq!(id, Ok(EventAttributeCount { count: "12345".to_string() }))
}